﻿// ----------------------------------------------------------------------------
// Fiserv COP GUI/Presentation Framework
// cop.js
// Copyright Fiserv, 2009
// ----------------------------------------------------------------------------

// Config Settings
//#region
//-------------------------
var isStaticData = false;
var defaultLayoutMode = "Dashboard"; // Dashboard/Loan
var currentLayoutMode = "DashboardLayout"; // Dashboard/Loan
var COPStatus = {
    "Ready": "<table><tr><td></td><td>Ready</td></tr></table>",
    "Saved": "Saved",
    "UnSaved": "UnSaved",
    "Saving": "Saving",
    "UpdLoanData": "Updating Loan Data",
    "UpdaEntData": "Updating Entities Data",
    "UpdCollData": "Updating Collateral Data",
    "UpdSerData": "Updating Services Data",
    "UpdRatios": "Updating Ratios",
    "ChkNotifications": "Checking for Notifications",
    "LoadForm": "Loading Form",
    "LoadDashboard": "<img src='../imgs/ajax-loader.gif' alt='Loading Dashboard' />Loading Dashboard"
};
var Layout1;
var Layout2;
var layoutReceivedMessage;
var layoutSentMessage;
var layoutComposeMessage;
var umsgObj; //User Messages Json object
var editor;
var receivedMessagesSelectedRowID;
var sentMessagesGrid;
var receivedMessagesGrid;
var messageEditor;
var notificationInterval = 30000;
var msgWindow;
var tabbarMessages;
var keycode;
var imgPath = "../codebase/imgs/";
//var imgMenuIconPath = "../codebase/imgs/dhxmenu_dhx_blue/";

var imgMenuIconPath = "../DHTMLX/dhtmlxMenu/images/";
var imgToolbarIconPath = "../DHTMLX/dhtmlxToolbar/images/";

var imgPathAccordion = "../DHTMLX/dhtmlxAccordion/codebase/imgs/dhxaccord_c594/";
var imgPathGrid = "../DHTMLX/dhtmlxGrid/codebase/imgs/";
var imgPathLayout = "../DHTMLX/dhtmlxLayout/imgs/dhxlayout_c594/";
var imgPathMenu = "../DHTMLX/dhtmlxMenu/codebase/imgs/";
var imgPathTabbar = "../DHTMLX/dhtmlxTabbar/codebase/imgs/";
var imgPathToolbar = "../DHTMLX/dhtmlxToolbar/codebase/imgs/dhxtoolbar_c594/";
var imgPathTree = "../DHTMLX/dhtmlxTree/codebase/imgs/csh_vista/";
var imgPathWindow = "../DHTMLX/dhtmlxWindows/codebase/imgs/dhxwins_c594/";

var xmlLoanMainMenu = "../xml/LoanMainMenu.xml";
var xmlModeTabs = "../xml/LoanTabs.xml";
var xmlDashTabs = "../xml/DashTabs.xml";
var xmlKeywords = "../xml/KeywordGrid.xml";
var xmlEntMenu = "../xml/EntMenu.xml";
var xmlEntTree = "../xml/EntTree.xml";
var xmlColMenu = "../xml/ColMenu.xml";
var xmlColGrid = "../xml/CollateralTree.xml";
var xmlSerGrid = "../xml/SerGrid.xml";  //TestGrid.xml
var xmlGUIToolsTabs = "../GUITools/GUIToolsTabset.xml";

var htmlBanner = "../content/banner.html"
var htmlIcon = "../content/Icons.aspx"
var htmlThumbnail = "../content/thumbnail.aspx";
var htmlCOPAlert = "../content/COPAlert.html";
var htmlRatios = "../content/ratios.html";
var htmlSubGrid = "../content/Page5.html";
var htmlPopup = "../content/Page3.html";
var htmlColPopup = "../content/CollPopup.html";
var htmlEntPopup = "../content/EntPopup.html";
var xmlSubTabs = "../xml/SubTabs.xml";
var lastSelectedRow;
var isParentChild = "false"; 
var mCal;
var checkedKeywords = [];
var licenseKey;
//#endregion

// doOnLoad() - runs from body onLoad event
//#region
//-------------------------
/**
* Called in the Body OnLoad event of Layout.html
* It creates the layout of COP GUI and initializes 
* the various components like the Top Menu, 
* left Accordian panels, and content panel
*/


function initCalendarObj()
{
  mCal = new dhtmlxCalendarObject("div1", false, {isYearEditable: true});
  mCal.attachEvent("onClick",mSelectDate);
  mCal.draw();
  mCal.hide();
}
function doOnLoad() {   
    
    Layout1 = new dhtmlXLayoutObject(document.body, "3T", "c594");    
    // Layout1
    Layout1.setImagePath(imgPathAccordion);   
    Layout1.cells("a").setHeight(66);
    Layout1.cells("a").hideHeader();
    Layout1.cells("a").attachURL(htmlBanner);
    Layout1.cells("b").setWidth(230);
    Layout1.cells("b").hideHeader();
    Layout1.cells("c").hideHeader();    
    Layout1.cells("a").fixSize(true, true);
    Layout1.cells("b").fixSize(true, true);
    Layout1.cells("c").fixSize(true, true);

    COPTabs = Layout1.cells("c").attachTabbar();
    COPTabs.setSkin("c594");
    Status = Layout1.attachStatusBar();        
    COPCommon.setStatus(COPStatus.Ready);

//    // Layout2
    Layout2 = new dhtmlXLayoutObject(Layout1.cells("b"), "2E", "c594");   
    Layout2.cells("a").hideHeader();
    Layout2.cells("a").setHeight(100);
    Layout2.cells("a").attachURL(htmlThumbnail);
    Layout2.cells("b").hideHeader();
    Layout2.cells("a").fixSize(true, true);
    Layout2.cells("b").fixSize(true, true);
    Accord = Layout2.cells("b").attachAccordion();   
    Accord.addItem("b1", "<table id='tblEntityMenu' width='100%'><tr><td>Entities</td><td align='right' id='tdEntityMenu'><div id='colortab'><a href='#' style='text-decoration:none; color:#6E6E6E'  rel='mEdit'>New</a></div></td></tr></table>");
  
    Accord.addItem("b2", "<table id='tblCollateralMenu' width='100%'><tr><td>Collateral</td><td align='right' id='tdCollateralMenu'></td></tr></table>");
    Accord.addItem("b3", "<table width='100%'><tr><td colspan='2'>Loan Ratios</td></tr></table>");
    Accord.addItem("b4", "<table width='100%'><tr><td colspan='2'>Third Party Services</td></tr></table>");
    Accord.addItem("b5", "<table width='100%'><tr><td colspan='2'>Keywords</td></tr></table>");
    Accord.attachEvent("onActive", function(itemId){
        if(itemId != "b1")
        {
           document.getElementById("tdEntityMenu").style.visibility = "hidden";
        }
        else if(itemId == "b1")
        {
            document.getElementById("tdEntityMenu").style.visibility = "visible";
        }
     });    
    
    GUITools.initGUITools();
    COPMenu.initMainMenu();
    COPContent.initContent();        
    GUITools.LogMessage('GUI Initialization Complete', 1);    
}
//#endregion

// COP Main Menu 
//#region
//-------------------------
/** @namespace */
var COPMenu = window.COPMenu || {};
COPMenu = function() {
    /** @private */

    function logout()
    {
        var intTop = 0;
        var intLeft = 0;
        var strFeatures = "location=no,menubar=no,resizable=no,scrollbars=no,toolbar=no,directories=no,top=" + intTop + ",left=" + intLeft + ",height=708,width=1015";       
        var relPath = "../../Login.aspx";
        window.open(relPath, "_parent", strFeatures);            
    }

    function onClick(id, zoneId, casState) {
        if (id == "m6-2") COPCommon.showDHTMLXPopup(htmlPopup, 50, 50, 900, 600, true, 'HMDA Export', true);
        // Dashboard Menu
        if ((id == "m10-1") || (id.indexOf("md1-")!=-1)) {
            COPTabs = Layout1.cells("c").attachTabbar();
            COPTabs.setSkin("c594");
            COPTabs.setImagePath(imgPathTabbar);
            COPContent.DashboardMode(id, MainMenu.getItemText(id));   
            
            COPMenu.hideMenuItems();
            currentLayoutMode="DashboardLayout";
            COPContext.showHideTabset();
        }

        // Log Off Menu Item
        if (id == "m12") {            
             logout();         
        }
        
        // Fees Tab
        if (id == "m5-1") COPCommon.showDHTMLXPopup(htmlSubGrid, 50, 50, 900, 600, true, 'Fees/Charges', true); 
        
        // GUI Tools
        if (id == "m8-2") GUITools.showGUITools();
        
        // Icons and Imags
        if(id == "m8-5") COPCommon.showDHTMLXPopup(htmlIcon, 100, 100, 700, 450, true, 'Icons', true); 

        // Product Admin
        if(id == "m7-1")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/Product/Default.aspx', 50, 50, 900, 600, true, 'Product Admin', true); 
//            Layout1.cells("b").collapse();            
//            COPMenu.hideMenuItems(); 
//            Layout1.cells("c").attachURL("../../../Admin/Product/Default.aspx");
        }

        // Fees Admin
        if(id == "m7-2")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/FeesAdmin/Default.aspx', 50, 50, 900, 600, true, 'Fees Admin', true); 
        }

        // Roles/ Permissions
        if(id == "m7-3")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/Permissions/Default.aspx', 50, 50, 900, 600, true, 'Roles/ Permissions Admin', true); 
        }

        // User Info Update
        if(id == "m7-4")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/permissions/users/UserSearchUpdate.aspx', 50, 50, 900, 600, true, 'User Info Update', true); 
        }

        // Password Policy
        if(id == "m7-5")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/PasswordPolicy/Default.aspx', 50, 50, 900, 600, true, 'Password Policy', true); 
        }

        // Vendor Admin
        if(id == "m7-6")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/ThirdParty/Admin.aspx', 50, 50, 900, 600, true, 'Vendor Admin', true); 
        }

        // Calendar Admin
        if(id == "m7-7")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/CompanyCalendar/default.aspx', 50, 50, 900, 600, true, 'Calendar Admin', true); 
        }

        // Forms Admin
        if(id == "m7-8")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Admin/FormsAdmin/Default.aspx', 50, 50, 900, 600, true, 'Forms Admin', true); 
        }

        // HELOC Calculator
        if(id == "m4-1")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Includes/Calcs/HelocCalc.aspx', 250, 100, 450, 550, true, 'HELOC Calculator', true); 
        }

        // Payoff Calculator
        if(id == "m4-2")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Includes/Calcs/AccPayoffSchedule.aspx', 250, 100, 480, 580, true, 'Payoff Calculator', true); 
        }

        // Net Effective Rate Calculator
        if(id == "m4-3")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Includes/Calcs/NetEffectiveRateCalculator.aspx', 250, 100, 350, 430, true, 'Net Effective Rate Calculator', true); 
        }

        // DTI Calculator
        if(id == "m4-4")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Includes/Calcs/DtiCalc.aspx', 250, 100, 340, 180, true, 'DTI Calculator', true); 
        }

        // Monthly Payment Calculator
        if(id == "m4-5")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Includes/Calcs/MonthlyPaymentCalc.aspx', 250, 100, 330, 270, true, 'Monthly Payment Calculator', true); 
        }
        
        // Income Calculator
        if(id == "m4-6")
        {
            COPCommon.showDHTMLXPopup('../../../Base/Includes/Calcs/IncomeCalc.aspx', 250, 100, 420, 480, true, 'Income Calculator', true); 
        }
        // Amortization Schedule Calculator
//        if(id == "m4-7")
//        {
//            COPCommon.showDHTMLXPopup('../AmortizationCalc/Calculator.aspx?loanId=69&scenarioId=66&principalBalance=0.00&loanPurpose=Purchase&rate=0.000&isRegistered=true', 50, 50, 900, 600, false, 'Product Admin', false); 
//        }
        GUITools.LogMessage("MainMenu Click: id=" + id + "   zoneId=" + zoneId + "   casState=" + casState, 1);
    }

    /** @private */
    function success(result) {
        MainMenu.loadXMLString(result);   
        COPMenu.hideMenuItems();    
    }

    /** @private */
    function failure() {

    }
       
    // public methods
    /** @scope COPMenu */
    return {
        /** Initialize the main (top) menu  */
        initMainMenu: function() {
            MainMenu = Layout1.attachMenu();
            MainMenu.setImagePath(imgPathMenu);
            MainMenu.setIconsPath(imgMenuIconPath);

            COPMenu.getMainMenu();        
            MainMenu.attachEvent("onClick", onClick);
            GUITools.LogMessage('MainMenu Initialized', 1);
        },

        /** 
        * Gets the main menu data either from a static xml file or from the WCF service
        */
        getMainMenu: function() {
            if (isStaticData) {
                MainMenu.loadXML(xmlLoanMainMenu,COPMenu.hideMenuItems);
            }
            else {
                var obj = new GUIServices.GUIService();
                obj.GetMainMenu(success, failure);
            }
        },
        
        /** 
        * Function to hide menu items based on Dashboard / Loan Mode
        */
        hideMenuItems : function(){
            COPMenu.hide("m2");
            COPMenu.hide("m3");
            COPMenu.hide("m4");
            COPMenu.hide("m5");
            COPMenu.hide("m6");
            COPMenu.hide("m10-2");
        },

        /** 
        * Function to show menu items based on Dashboard / Loan Mode
        */
        showMenuItems : function(){
            COPMenu.show("m2");
            COPMenu.show("m3");
            COPMenu.show("m4");
            COPMenu.show("m5");
            COPMenu.show("m6");
        },

        /** Hides a main (top) menu  Item 
        * @param id ID of the Menu Item that is to be hidden */
        hide: function(id) {
            MainMenu.hideItem(id);
            GUITools.LogMessage('MainMenu Item Hidden', 1);
        },

        /** Shows a main (top) menu  Item 
        * @param id ID of the Menu Item that is to be shown */
        show: function(id) {
            MainMenu.showItem(id);
            GUITools.LogMessage('MainMenu Item Shown', 1);
        },

        /** Disables a main (top) menu  Item 
        * @param id ID of the Menu Item that is to be disabled */
        disable: function(id) {
            MainMenu.setItemDisabled(id);
            GUITools.LogMessage('MainMenu Item Disabled', 1);
        },

        /** Enables a main (top) menu  Item 
        * @param id ID of the Menu Item that is to be enabled */
        enable: function(id) {
            MainMenu.setItemEnabled(id);
            GUITools.LogMessage('MainMenu Item Enabled', 1);
        }
    };
} ();
//#endregion

// COP Message
//#region
//-------------------------
/** @namespace */
var COPMessage = window.COPMessage || {};
COPMessage = function() {
    /** @private */
    function objtoxml(obj, id, deleteFlag, d) {
        id = (id) ? id : "ID";
        deleteFlag = (deleteFlag) ? deleteFlag : null;
        d = (d) ? d : 0;
        var rString = "\n";
        var pad = "";

        for (var i = 0; i < d; i++) {
            pad += " ";
        }

        if (obj != null) {
            if (typeof obj === "object") {
                if (obj.constructor.toString().indexOf("Array") !== -1) {
                    for (i = 0; i < obj.length; i++) {
                        if (i == 0) {
                            rString += ((rString === "\n") ? "" : "\n") + pad + "<head>";
                            rString += ((rString === "\n") ? "" : "\n") + pad + "<column width='50' type='img' align='center' sort='na' hidden='no'>Delete</column>";
                            for (var j in obj[i]) {
                                rString += ((rString === "\n") ? "" : "\n") + pad + "<column id='" + j + "' width='100' type='ro' align='left' sort='na'>" + j + "</column>";
                            }
                            rString += ((rString === "\n") ? "" : "\n") + pad + "</head>\n";
                        }
                        if (typeof (obj[i][id]) != "undefined") {
                            if (deleteFlag == null || typeof obj[i][deleteFlag] == "undefined") {
                                rString += pad + "<row id = '" + obj[i][id] + "'><cell>../imgs/delete.gif^Delete Message^javascript:COPMessage.MessageDelete(" + obj[i][id] + ")^_self</cell>" + objtoxml(obj[i], id, deleteFlag, d + 1) + "</row>\n";
                            }
                            else if (typeof obj[i][deleteFlag] != "undefined") {
                                if (obj[i][deleteFlag] == true) {
                                    rString += pad + "<row id = '" + obj[i][id] + "'><cell>../imgs/delete.gif^Delete Message^javascript:COPMessage.MessageDelete(" + obj[i][id] + ")^_self</cell>" + objtoxml(obj[i], id, deleteFlag, d + 1) + "</row>\n";
                                }
                                else {
                                    rString += pad + "<row id = '" + obj[i][id] + "'><cell>../imgs/_blank.gif</cell>" + objtoxml(obj[i], id, deleteFlag, d + 1) + "</row>\n";
                                }
                            }
                        }
                    }
                    rString = rString.substr(0, rString.length - 1)
                } else {
                    for (i in obj) {
                        var val = objtoxml(obj[i], id, deleteFlag, d + 1);
                        if (!val)
                            return false;
                        if (i == "Table" || i == "rows") {
                            rString += ((rString === "\n") ? "" : "\n") + pad + "<rows>" + val + ((typeof obj[i] === "object") ? "\n" + pad : "") + "</rows>";
                        }
                        else {
                            if (val != "\n" && val != "") {
                                rString += ((rString === "\n") ? "" : "\n") + pad + "<cell><![CDATA[<div>" + val + ((typeof obj[i] === "object") ? "\n" + pad : "") + "</div>]]></cell>";
                            }
                            else {
                                rString += ((rString === "\n") ? "" : "\n") + pad + "<cell>" + val + ((typeof obj[i] === "object") ? "\n" + pad : "") + "</cell>";
                            }
                        }
                    }
                }
            } else if (typeof obj === "string") {
                rString = obj;
            } else if (obj.toString) {
                rString = obj.toString();
            } else {
                return false;
            }
        }
        return rString;
    }

    /** @private */
    function successUserNotification(result) {
        umsgObj = JSON.parse(result);

        if (umsgObj.Table.length > 0) {
            var newMessages = false;
            for (var i = 0; i < umsgObj.Table.length; i++) {
                if (umsgObj.Table[i]["Read Time"] == null) {
                    newMessages = true;
                }
                if (umsgObj.Table[i].Received != null) {
                    var receivedTime = eval(umsgObj.Table[i].Received);
                    umsgObj.Table[i].Received = receivedTime.toString();
                }
            }
            if (newMessages == true) {
                Layout1.cells("a")._frame.contentWindow.document.getElementById("imgUserNotification").src = "../imgs/unread.GIF";
                Layout1.cells("a")._frame.contentWindow.document.getElementById("imgUserNotification").alt = "There are new messages waiting for you";
            }
            else if (newMessages == false) {
                Layout1.cells("a")._frame.contentWindow.document.getElementById("imgUserNotification").src = "../imgs/read.GIF";
                Layout1.cells("a")._frame.contentWindow.document.getElementById("imgUserNotification").alt = "No new messages";
            }
        }
    }

    function failureUserNotification() {
        COPCommon.ShowAlert("Failed to retreive user notification message");
    }

    function successSendMessage(result) {
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Message Send Successfully");
        layoutComposeMessage.cells("a")._frame.contentWindow.document.getElementById("MessageTo").value = "";
        editor.setContent("");
    }

    function failureSendMessage() {
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Failed to send message");
    }

    function successGetSentMessages(result) {
        var xmlForSentMessages;
        var uSentMsgObj;
        var rowCount;

        uSentMsgObj = JSON.parse(result);

        rowCount = uSentMsgObj.Table.length;

        if (rowCount > 0) {
            for (var i = 0; i < rowCount; i++) {
                if (uSentMsgObj.Table[i].Sent != null) {
                    var sentTime = eval(uSentMsgObj.Table[i].Sent);
                    uSentMsgObj.Table[i].Sent = sentTime.toString();
                }
            }
            xmlForSentMessages = objtoxml(uSentMsgObj, "Message ID", "Allow Delete");

            if (xmlForSentMessages != false) {
                sentMessagesGrid.loadXMLString(xmlForSentMessages);
            }
            sentMessagesGrid.setColWidth(0, "50");
            sentMessagesGrid.setColWidth(1, "250");
            sentMessagesGrid.setColWidth(2, "370");
            sentMessagesGrid.setColSorting("na,str,date");

            for (var columnIndex = 3; columnIndex < 22; columnIndex++) {
                sentMessagesGrid.setColumnHidden(columnIndex, true);
            }
        }
    }

    function failureGetSentMessages() {
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Failed to retreive user sent message");
    }

    function successUpdateMessageReadTime(result) {
        receivedMessagesGrid.setRowTextNormal(receivedMessagesSelectedRowID);
    }

    function failureUpdateMessageReadTime() {
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Failed to update read time for selected message");
        receivedMessagesGrid.setRowTextBold(receivedMessagesSelectedRowID);
    }

    function successDeleteReceivedMessage(result) {
        receivedMessagesGrid.deleteSelectedRows();
        layoutReceivedMessage.cells("b").window.attachHTMLString("");
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Message Deleted");
    }

    function failureDeleteReceivedMessage() {
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Failed to delete selected message");
    }

    function successDeleteSentMessage(result) {
        sentMessagesGrid.deleteSelectedRows();
        layoutSentMessage.cells("b").window.attachHTMLString("");
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Message(s) Deleted");
    }

    function failureDeleteSentMessage(result) {
        if (typeof msgWindow != "undefined") {
            if (msgWindow.isOnTop() == true) {
                msgWindow.bringToBottom();
            }
        }
        COPCommon.ShowAlert("Message(s) Deleted");
    }

    function sentMessagesGridOnRowCreated(id, obj, xml) {
        var severityIndex = this.getColIndexById("Severity");

        this.cellById(id, severityIndex).setValue("!")

        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "HIGH") {
            this.setCellTextStyle(id, severityIndex, "color:red;");
        }
        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "MEDIUM") {
            this.setCellTextStyle(id, severityIndex, "color:yellow;");
        }
        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "LOW") {
            this.setCellTextStyle(id, severityIndex, "color:green;");
        }
        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "NORMAL") {
            this.setCellTextStyle(id, severityIndex, "color:black;");
        }
    }

    function sentMessagesGridOnRowSelect(rowId, cellIndex) {
        var titleIndex;
        var title;
        var bodyIndex;
        var body;
        var toIndex;
        var to;
        var fromIndex;
        var from;
        var html;

        titleIndex = this.getColIndexById("Subject");
        bodyIndex = this.getColIndexById("Body");
        toIndex = this.getColIndexById("To");
        fromIndex = this.getColIndexById("From");

        to = this.cellById(rowId, toIndex).getValue();
        title = this.cellById(rowId, titleIndex).getValue();
        body = this.cellById(rowId, bodyIndex).getValue();
        from = this.cellById(rowId, fromIndex).getValue();
        html = "<table><tr><td>To</td><td>:</td><td>" + to + "</td></tr><tr><td>From</td><td>:</td><td>" + from + "</td></tr></table><hr /><br />" + body;

        layoutSentMessage.cells("b").window.attachHTMLString(html);
    }

    function receivedMessagesGridOnRowSelect(rowId, cellIndex) {
        var titleIndex;
        var title;
        var bodyIndex;
        var body;
        var toIndex;
        var to;
        var fromIndex;
        var from;
        var readtimeIndex;
        var html;
        var obj;
        var msgId;

        titleIndex = this.getColIndexById("Subject");
        bodyIndex = this.getColIndexById("Body");
        toIndex = this.getColIndexById("To");
        fromIndex = this.getColIndexById("From");
        readtimeIndex = this.getColIndexById("Read Time");

        msgId = rowId;
        title = this.cellById(rowId, titleIndex).getValue();
        body = this.cellById(rowId, bodyIndex).getValue();
        to = this.cellById(rowId, toIndex).getValue();
        from = this.cellById(rowId, fromIndex).getValue();
        html = "<table><tr><td>From</td><td>:</td><td>" + from + "</td></tr><tr><td>To</td><td>:</td><td>" + to + "</td></tr></table><hr /><br />" + body;
        layoutReceivedMessage.cells("b").window.attachHTMLString(html);

        if (this.cells(rowId, readtimeIndex).cell.innerText == " ") {
            receivedMessagesSelectedRowID = rowId;
            obj = new GUIServices.GUIService();
            obj.UpdateMessageReadTime(msgId, successUpdateMessageReadTime, failureUpdateMessageReadTime);
        }
    }

    function receivedMessagesGridOnRowCreated(id, obj, xml) {
        var severityIndex = this.getColIndexById("Severity");
        var readtimeIndex = this.getColIndexById("Read Time");

        this.cellById(id, severityIndex).setValue("!")

        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "HIGH") {
            this.setCellTextStyle(id, severityIndex, "color:red;");
        }
        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "MEDIUM") {
            this.setCellTextStyle(id, severityIndex, "color:yellow;");
        }
        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "LOW") {
            this.setCellTextStyle(id, severityIndex, "color:green;");
        }
        if (this.cells(id, severityIndex).cell.innerText.toUpperCase() == "NORMAL") {
            this.setCellTextStyle(id, severityIndex, "color:black;");
        }
        if (this.cells(id, readtimeIndex).cell.innerText == " ") {
            this.setRowTextBold(id);
        }
    }

    function tabbarClick(id) {
        var xmlForSentMessages;
        var obj;

        if (id == "Received") {
            this.setTabActive("Received", false);
        }
        else if (id == "Sent") {
            this.setTabActive("Sent", false);
            obj = new GUIServices.GUIService();
            obj.GetSentMessages(successGetSentMessages, failureGetSentMessages);
        }
        else if (id == "Compose") {
            this.setTabActive("Compose", false);
        }
    }

    document.onkeydown = checkKeycode

    function checkKeycode(e) {
        if (window.event) {
            keycode = window.event.keyCode;
        }
    }

    // public methods
    /** @scope COPMessage */
    return {

        initNotificationPolling: function() {
            var pollingInterval = setInterval("COPMessage.getUserMessages()", notificationInterval);
        },

        getUserMessages: function() {
            var obj = new GUIServices.GUIService();
            obj.GetUserNotifications(successUserNotification, failureUserNotification);
        },

        MessageDelete: function(id) {
            var obj;
            var activeTab;

            activeTab = tabbarMessages.getActiveTab();

            if (activeTab == "Received") {
                obj = new GUIServices.GUIService();
                obj.DeleteMessage(id, "Received", successDeleteReceivedMessage, failureDeleteReceivedMessage);
            }
            else if (activeTab == "Sent") {
                obj = new GUIServices.GUIService();
                obj.DeleteMessage(id, "Sent", successDeleteSentMessage, failureDeleteSentMessage);
            }
        },

        sendMessage: function() {
            var recipient;
            var message;
            var obj;

            recipient = layoutComposeMessage.cells("a")._frame.contentWindow.document.getElementById("MessageTo").value;
            message = editor.getContent();

            if (recipient == "") {
                if (typeof msgWindow != "undefined") {
                    if (msgWindow.isOnTop() == true) {
                        msgWindow.bringToBottom();
                    }
                }
                COPCommon.ShowAlert("To cannot be empty");
            }

            if (message == "") {
                if (typeof msgWindow != "undefined") {
                    if (msgWindow.isOnTop() == true) {
                        msgWindow.bringToBottom();
                    }
                }
                COPCommon.ShowAlert("Message Body cannot be empty");
            }

            if ((recipient != "") && (message != "")) {
                obj = new GUIServices.GUIService();
                obj.SendMessage(recipient, message, successSendMessage, failureSendMessage);
            }
        },

        //User Message Dialog
        loadMessageDialog: function() {
            var xmlForMessages;
            var dhxWins1;
            var receivedMessagesCount;

            dhxWins1 = new dhtmlXWindows();
            dhxWins1.setImagePath(imgPathWindow);
            dhxWins1.setSkin("c594");

            msgWindow = dhxWins1.createWindow("MsgWindow", 50, 50, 700, 450);
            msgWindow.setText("User Messages");
            msgWindow.center();

            tabbarMessages = msgWindow.attachTabbar();
            tabbarMessages.setImagePath(imgPathTabbar);
            tabbarMessages.setSkin("c594");

            layoutReceivedMessage = tabbarMessages._cells(dhxWins1, "Received").attachLayout("2E", "c594");
            layoutSentMessage = tabbarMessages._cells(dhxWins1, "Sent").attachLayout("2E", "c594");
            layoutComposeMessage = tabbarMessages._cells(dhxWins1, "Compose").attachLayout("1C", "c594");

            layoutReceivedMessage.cells("a").hideHeader();
            layoutReceivedMessage.cells("b").hideHeader();
            layoutSentMessage.cells("a").hideHeader();
            layoutSentMessage.cells("b").hideHeader();
            layoutComposeMessage.cells("a").hideHeader();

            tabbarMessages.setTabActive("Received", false);

            tabbarMessages.attachEvent("onSelect", tabbarClick);

            receivedMessagesGrid = layoutReceivedMessage.cells("a").attachGrid();
            receivedMessagesGrid.setImagePath(imgPathGrid);
            receivedMessagesGrid.setSkin("c594");

            receivedMessagesCount = umsgObj.Table.length;

            if (receivedMessagesCount > 0) {
                receivedMessagesGrid.attachEvent("onRowCreated", receivedMessagesGridOnRowCreated);
                receivedMessagesGrid.init();
                xmlForMessages = objtoxml(umsgObj, "Message ID", "Allow Delete");
                receivedMessagesGrid.loadXMLString(xmlForMessages);
                for (var columnIndex = 5; columnIndex < 22; columnIndex++) {
                    receivedMessagesGrid.setColumnHidden(columnIndex, true);
                }
                receivedMessagesGrid.setColWidth(0, "50");
                receivedMessagesGrid.setColWidth(1, "100");
                receivedMessagesGrid.setColWidth(2, "150");
                receivedMessagesGrid.setColWidth(3, "100");
                receivedMessagesGrid.setColWidth(4, "270");
                receivedMessagesGrid.attachEvent("onRowSelect", receivedMessagesGridOnRowSelect);
            }
            else {
                receivedMessagesGrid.setHeader("Delete,From,Received,Loan #,Subject");
                receivedMessagesGrid.setColWidth(0, "50");
                receivedMessagesGrid.setColWidth(1, "100");
                receivedMessagesGrid.setColWidth(2, "150");
                receivedMessagesGrid.setColWidth(3, "100");
                receivedMessagesGrid.setColWidth(4, "270");
                receivedMessagesGrid.init();
            }

            receivedMessagesGrid.setColSorting("na, str,date,int,str");

            sentMessagesGrid = layoutSentMessage.cells("a").attachGrid();
            sentMessagesGrid.setImagePath(imgPathGrid);
            sentMessagesGrid.setSkin("c594");
            sentMessagesGrid.setHeader("Delete,To,Sent");
            sentMessagesGrid.setColWidth(0, "50");
            sentMessagesGrid.setColWidth(1, "250");
            sentMessagesGrid.setColWidth(2, "370");
            sentMessagesGrid.setColSorting("na,str,date");
            sentMessagesGrid.init();
            sentMessagesGrid.attachEvent("onRowSelect", sentMessagesGridOnRowSelect);
            sentMessagesGrid.attachEvent("onRowCreated", sentMessagesGridOnRowCreated);

            layoutComposeMessage.cells("a").attachURL("ComposeMessage.html");

        }
    }
} ();
//#endregion

// COP Content 
//#region
//-------------------------
/** @namespace */
var COPContent = window.COPContent || {};
COPContent = function() {

    /** @private */
    function successGetDashboardTabs(result) {       
        if(result=="")
        {
            COPCommon.ShowAlert("There are no loan stages assigned to your role!");
        }
        else
        {
            COPTabs.loadXMLString(result);
            COPContext.getUserContext();
        }
    }

    /** @private */
    function failureGetDashboardTabs() {
        COPCommon.ShowAlert('Error in loading tabsets');
    }
   
  /** @private */
    function successGetLoanTabs(result) {
        COPTabs.loadXMLString(result);
        COPKeywords.ApplyKeywordsToLoanTabs(result);
    }

    /** @private */
    function failureGetLoanTabs() {
        COPCommon.ShowAlert('Error in loading tabsets');
    }
    
    // public methods
    /** @scope COPContent */
    return {
        /**Initialize the layout based on Dashboard mode and Loan Mode 
        * @param mode Either Dashboard Mode or Loan Mode */
        initContent: function(mode) {            
            COPTabs.setImagePath(imgPathTabbar);
            if (defaultLayoutMode == "Dashboard") {
                COPContent.DashboardMode(null,null);
            }
            if (defaultLayoutMode == "Loan") {
                COPContent.LoanMode();
            }
            GUITools.LogMessage('Content Initialized', 1);
        },
        
        /** Load Loan Tabsets */
        LoanMode: function() {
            Layout1.cells("b").expand();
            var ddlTabs = Layout1.cells("a")._frame.contentWindow.document.getElementById("ddlTabsets");            
            var tabset = ddlTabs.options[ddlTabs.selectedIndex].text;
            COPContent.getLoanTabs(null, tabset);
        },
        /** Switch to dashboard mode*/
        DashboardMode: function(menuId,menuText) {            
            Layout1.cells("b").collapse();
            COPContent.getDashboardTabs(null,menuId,menuText);            
        },

        /** Method to get the Dashboard tabs data */
        getDashboardTabs: function(xmlString,menuId,menuText) {
            if (xmlString != null) {
                COPTabs.loadXMLString(xmlString);
            }
            else {
                if (isStaticData) {
                    COPTabs.loadXML(xmlDashTabs);
                }
                else {
                    var obj = new GUIServices.GUIService();
                    obj.GetDashboardTabs(menuId,menuText,successGetDashboardTabs, failureGetDashboardTabs);
                }
            }
        },

        /** Method to get the Loan tabs data */
        getLoanTabs: function(xmlString, tabsetName) {
            if (xmlString != null) {
                COPTabs.loadXMLString(xmlString)
            }
            else {
                if (isStaticData) {
                    COPTabs.loadXML(xmlModeTabs);
                }
                else {
                    var obj = new GUIServices.GUIService();
                    obj.GetLoanTabs(tabsetName, successGetLoanTabs, failureGetLoanTabs);
                }
            }
        },
                        
        /** Open a specific Tab form the Loan Tabset
        * @param tabId ID of the tab to be set as active tab. */
        openTab: function(tabId) {
            COPTabs.setTabActive(tabId);
        },

        /** Go to Next tab 
        * @param tabId ID of the current active tab */
        nextTab: function(tabId) {
            COPTabs.goToNextTab(tabId);
        },

        /** Go to Previous tab
        * @param tabId ID of the current active tab */
        prevTab: function(tabId) {
            COPTabs.goToPrevTab(tabId);
        }
    }
} ();
//#endregion

// COP Banner
//#region
//-------------------------
/** @namespace */
var COPContext = window.COPContext || {};
COPContext = function() {
    /** @private */
    function successGetUserContext(result)
    {
        var ucontextObj = JSON.parse(result);
        // BANNER
        Layout1.cells("a")._frame.contentWindow.document.getElementById("divUserName").innerHTML = ucontextObj.userName;
        Layout1.cells("a")._frame.contentWindow.document.getElementById("divBranch").innerHTML = ucontextObj.branch;
        Layout1.cells("a")._frame.contentWindow.document.getElementById("divRole").innerHTML = ucontextObj.role;
        COPMessage.getUserMessages();
        COPMessage.initNotificationPolling();
    }

    function successGetLoanContext(result)
    {
        var lcontextObj = JSON.parse(result);
        // THUMBNAIL        
        Layout2.cells("a")._frame.contentWindow.document.getElementById("divLoanID").innerHTML = lcontextObj.loanID;
        Layout2.cells("a")._frame.contentWindow.document.getElementById("hdnLoanId").value = lcontextObj.loanID;
        Layout2.cells("a")._frame.contentWindow.document.getElementById("divStage").innerHTML = lcontextObj.stage;
        Layout2.cells("a")._frame.contentWindow.document.getElementById("divStatus").innerHTML = lcontextObj.status;
        Layout2.cells("a")._frame.contentWindow.document.getElementById("divOrigin").innerHTML = lcontextObj.origin;        
        var borrowerName = "<a onclick='displaySummaryPanel("+lcontextObj.loanNumber+");' title='Click to view Loan Summary'  style='color: #0000FF; text-decoration: underline; cursor:pointer;'>" + lcontextObj.borrName + "</a>";
        Layout2.cells("a")._frame.contentWindow.document.getElementById("divBorrName").innerHTML = borrowerName; 
    }

    /** @private */
    function failureGetUserContext() {
        COPCommon.ShowAlert("Error getting user context");
    }

    /** @private */
    function failureGetLoanContext() {
        COPCommon.ShowAlert("Error getting loan context");
    }

     /** @private */
    function successSetLoanContext(result){
        if(result==false){
            COPCommon.ShowAlert("Loan Context not set");
        }
        else
        {            
            // initialize the accordian once there is a loan in context
            COPKeywords.initKeywords();
            COPContext.initThumbnail();
            COPEntities.initEntities();            
            tabdropdown.init('colortab', 'auto');
            COPCollateral.initCollateral();
            COPThirdParty.initThirdParty();
            COPRatios.initRatios();
            
            // switch to loan mode
            COPContent.LoanMode();
            COPMenu.showMenuItems();
            currentLayoutMode="LoanLayout";
            COPContext.showHideTabset();
        }
    }
    
     /** @private */
    function failureSetLoanContext(){
        COPCommon.ShowAlert("Error setting loan context")
    }

     /** @private */
    function successBannerTabs(result){        
        var ddlTabs = Layout1.cells("a")._frame.contentWindow.document.getElementById("ddlTabsets");
        var tabArray = result.split(',');
        for (var i = 0; i < tabArray.length; i++)
            ddlTabs.options[ddlTabs.length] = new Option(tabArray [i++], tabArray [i])
    }

     /** @private */
    function failureBannerTabs(){
        COPCommon.ShowAlert("Error setting banner tabsets")
    }

    /** @scope COPContext */
    return {
        /** Method the refresh Banner */
        getUserContext : function()
        {
            var obj = new GUIServices.GUIService();
            obj.GetUserContext(successGetUserContext, failureGetUserContext);
        },

        /** Method the refresh thumbnail */
        getLoanContext : function()
        {
            var obj = new GUIServices.GUIService();
            obj.GetLoanContext(successGetLoanContext, failureGetLoanContext);
        },        

        /** Method the Loan the tabsets dynamically */
        loadTabsets : function(tabsetName)
        {         
            COPContent.getLoanTabs(null,tabsetName);           
        },
        
        /** Method to populate the Bannet tabset dropdown */
        getBannerTabs : function() {
            var obj = new GUIServices.GUIService();
            obj.GetLoanTabsets(successBannerTabs, failureBannerTabs);           
        },
        
        /**Initialize the Loan Summary Thumbnail containing the borrower name and links to Loan summary and actionable Lock Loan link*/
        initThumbnail: function() {
            //Layout2.cells("a").attachURL(htmlThumbnail);
            COPContext.getLoanContext();
            GUITools.LogMessage('Thumbnail Initialized', 1);
        },

        /** Opens the Loan Summary screen containing a brief summary of the Loan/ Borrower Details */
        popLoanSummary: function() {            
            COPCommon.showDHTMLXPopup('LoanSummary.html', 50, 50, 900, 600, true, 'Loan Summary', true); 
        },

        /** Opens the Lock Loan screen, where the user can lock the current Loan */
        lockRate: function() {
            // TODO
            COPCommon.showDHTMLXPopup('Page1.html', 50, 50, 900, 600, true, 'Loan Lock', true); 
        },

        /** Loads a Tabset in the main content frame */
        loadTabset: function(id) {
            // TODO
            COPCommon.showDHTMLXPopup('Page1.html', 50, 50, 900, 600, true, 'Common Origination Platform from Fiserv', true); 
        },

        /** Function to show/ hide Notification Icon on the Thumbnail*/
        showHideNotification : function(mode) {
            if(mode =='show')
                Layout2.cells("a")._frame.contentWindow.document.getElementById("divNotification").style.visibility = 'visible';
            else
                Layout2.cells("a")._frame.contentWindow.document.getElementById("divNotification").style.visibility = 'hidden'; 

        },

        /** Function to set Rollover text/ Tooltip on the Notification Icon on the Thumbnail*/
        setNotification : function(roolOverText) {            
                Layout2.cells("a")._frame.contentWindow.document.getElementById("imgAlert").alt = roolOverText;
        },

        /** Function to show/ hide Tabsets in the Banner */
        showHideTabset: function() {
            if(currentLayoutMode == "LoanLayout")
                Layout1.cells("a")._frame.contentWindow.document.getElementById("trTabsets").style.visibility = 'visible';               
            else
                Layout1.cells("a")._frame.contentWindow.document.getElementById("trTabsets").style.visibility = 'hidden'; 
           
        },

        /** Function to set Loan Context
        */
        setLoanContext : function(appId){
            var obj = new GUIServices.GUIService();
            obj.SetLoanContext(appId, successSetLoanContext, failureSetLoanContext);    
        }         
    }
} ();
//#endregion

// COP Keywords 
//#region
//-------------------------
/** @namespace */
var COPKeywords = window.COPKeywords || {};
COPKeywords = function() {

    /** @private*/
    function doOnCheckKeyword(RowID, CellID, boolChecked){
        var value = KeywordGrid.cellById(RowID,1).getValue();
        if(value != ""){
            if (boolChecked == 1) {
                //var key = checkedKeywords.find(value);          
                //if(key == false){
                //    checkedKeywords.push(value);
                    //COPCommon.GetLicenseKey();
                //}
                GUITools.LogMessage("Row=" + RowID + "  strKeyword " + CellID + " is checked", 1);
            }
            else {
                //var key = checkedKeywords.find(value);          
                //checkedKeywords.splice(key,1);    
                //COPCommon.GetLicenseKey();
                GUITools.LogMessage("Row=" + RowID + "  strKeyword " + CellID + " is un-checked", 1);
            }        
        }
    }

    /** @private */
    function success(result) {
         KeywordGrid.loadXMLString(result,function(){
            KeywordGrid.forEachRow(function(id){            
            if ((KeywordGrid.cellById(id,1).getValue()=="Mortgage") ||(KeywordGrid.cellById(id,1).getValue()=="Home Equity") ||(KeywordGrid.cellById(id,1).getValue()=="Consumer") ||(KeywordGrid.cellById(id,1).getValue()=="Business"))
                 KeywordGrid.setCellTextStyle(id,1,"color: #FF6600");
            else 
                KeywordGrid.setCellTextStyle(id,1,"color: black");
                
             if (KeywordGrid.cells(id,0).getValue()==1)
              checkedKeywords.push(KeywordGrid.cells(id,1).getValue());                
        }); 
        })
    }

    /** @private */
    function failure() {

    }

    /** @scope COPKeywords */
    return {
        /** Function to Initialize the Keywords grid*/
        initKeywords: function() {
            KeywordGrid = Accord.cells("b5").attachGrid();
            KeywordGrid.setSkin("c594");
            KeywordGrid.setImagePath(imgPathGrid);            
            KeywordGrid.setNoHeader(true);
            KeywordGrid.init();
            COPKeywords.getKeywords(null);           
            KeywordGrid.attachEvent("onCellChanged", doOnCheckKeyword);
            GUITools.LogMessage('Keywords Initialized', 1);
        },
        
        ApplyKeywordsToLoanTabs: function(tabsXML){
            try{            
                xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
                xmlDoc.async="false";
                xmlDoc.loadXML(tabsXML);
            }
            catch(e){
              parser=new DOMParser();
              xmlDoc=parser.parseFromString(txt,"text/xml");
            }                
            
            var rowNodes = xmlDoc.selectNodes("/tabbar/row");
            if (rowNodes != undefined){
                if (rowNodes.length > 0){
                    for(k = 0; k < rowNodes.length; k++){                
                        var tabNodes = rowNodes[k].selectNodes("tab");
                        if (tabNodes != undefined){
                            if (tabNodes.length > 0){
                                for(j = 0; j < tabNodes.length; j++){
                                    var tabID = tabNodes[j].getAttribute("id");
                                    tabIDArray = tabID.split('|');
                                    if ((tabIDArray[1] != undefined) && (tabIDArray[1] != "")){                                    
                                        tabsKeywords = tabIDArray[1].split(',');
                                        for(z = 0; z < tabsKeywords.length; z++){
                                            var key = tabsKeywords[z];
                                            if (checkedKeywords.find(key) == false){
                                                COPTabs.hideTab(tabID);                                            
                                            }
                                        }
                                    }
                                    else{
                                        //COPTabs.hideTab(tabID); 
                                    }
                                }
                            }                        
                        }
                    }
                }
            }
        },

        /** function to get the data for the Keywords grid */
        getKeywords: function(xmlString) {
            if (xmlString != null) {
                KeywordGrid.loadXMLString(xmlString);
            }
            else {
                if (isStaticData) {
                    KeywordGrid.loadXML(xmlKeywords,function(){
                        KeywordGrid.forEachRow(function(id){                        
                        if ((KeywordGrid.cellById(id,1).getValue()=="Mortgage") ||(KeywordGrid.cellById(id,1).getValue()=="Home Equity") ||(KeywordGrid.cellById(id,1).getValue()=="Consumer") ||(KeywordGrid.cellById(id,1).getValue()=="Business"))
                             KeywordGrid.setCellTextStyle(id,1,"color: #FF6600");
                        else 
                            KeywordGrid.setCellTextStyle(id,1,"color: black");
                        }); 
                    })
                }
                else {
                    var obj = new GUIServices.GUIService();
                    obj.GetKeywords(success, failure);
                }
            }
        },

        /** Function to interact with the Keywords grid from another page
        * @param key The value of the selected keyword */
        CheckKeyword: function(key) {
            var pos = KeywordGrid.findCell(key.value)
            if (pos != undefined) if (key.checked) KeywordGrid.cells(pos[0][0], 0).setChecked(true);
            else KeywordGrid.cells(pos[0][0], 0).setChecked(false);
        }

    }
} ();
//#endregion

// GUI Tools 
//#region
//-------------------------
/** @namespace */
var GUITools = window.GUITools || {};
GUITools = function() {

    // public methods
    /** @scope GUITools */
    return {
        /**Function to initialize the Debug mode for the application.*/
        initGUITools: function() {
            dhxWins1 = new dhtmlXWindows();
            dhxWins1.setImagePath(imgPathWindow);
            dhxWins1.setSkin("c594");
                        
            GUIToolsWin = dhxWins1.createWindow("GUIToolsWin", 240, 50, 600, 500);
            GUIToolsWin.setText("GUITools");
            
            dhxWins1.window("GUIToolsWin").button("close").attachEvent("onClick", function() {            
                GUIToolsWin.hide();
            });

            GUIToolsTabs = GUIToolsWin.attachTabbar();
            GUIToolsTabs.setImagePath(imgPathTabbar);
            GUIToolsTabs.setSkin("c594");
            //GUIToolsTabs.loadXML(xmlGUIToolsTabs);            
            
            GUIToolsTabs.setHrefMode("ajax-html");    
            
            GUIToolsTabs.addTab("tab1","Introduction","90px",0,0);            
            GUIToolsTabs.setContentHref("tab1","../GUITools/GUITools-Intro.html");
            
            GUIToolsTabs.addTab("tab2","Context","90px",0,0);            
            GUIToolsTabs.setContentHref("tab2","../GUITools/GUITools-Context.html");
            
            GUIToolsTabs.addTab("tab2","Context","100px",0,0);            
            GUIToolsTabs.setContentHref("tab2","../GUITools/GUITools-Context.html");
            
            GUIToolsTabs.addTab("tab3","Local Files","100px",0,0);            
            GUIToolsTabs.setContentHref("tab3","../GUITools/GUITools-ClientLog.html");
            
            GUIToolsTabs.addTab("tab4","Local System","100px",0,0);            
            GUIToolsTabs.setContentHref("tab4","../GUITools/GUITools-System.html");
            
            GUIToolsTabs.addTab("tab5","Documentation","100px",0,1);            
            GUIToolsTabs.setContentHref("tab5","../GUITools/GUITools-Documentation.html");
            
            GUIToolsTabs.addTab("tab21","Rules Engine Utility","120px",0,1);            
            GUIToolsTabs.setContentHref("tab21","../content/Page2.html");
            
            GUIToolsTabs.addTab("tab22","Integration Manager","120px",0,1);            
            GUIToolsTabs.setContentHref("tab22","../content/Page0.html");
            
            GUIToolsTabs.addTab("tab23","Service Hub Utility","120px",0,1);            
            GUIToolsTabs.setContentHref("tab23","../content/Page2.html");

            GUIToolsTabs.addTab("tab24","Carlton Calcs","120px",0,1);            
            GUIToolsTabs.setContentHref("tab24","../content/Page1.html");
            
            ClientLogGrid = GUIToolsTabs._cells(dhxWins1,"Debug").attachGrid(); 
			
			ClientLogGrid.setImagePath(imgPathGrid);
            ClientLogGrid.setSkin("c594");
			ClientLogGrid.setHeader("Date, Log");
			ClientLogGrid.setInitWidths("170,360")
			ClientLogGrid.setColAlign("left,left")
			ClientLogGrid.setColTypes("ro,ro");
			ClientLogGrid.setColSorting("int,str")
            ClientLogGrid.init();
                     
            GUIToolsTabs.setTabActive("tab1");
            GUIToolsWin.hide();
            GUITools.LogMessage('GUITools Initialized', 1);           
        },

        /**
        * Function to Show the GUI tools popup
        */
        showGUITools: function() {
            GUIToolsWin.show();
            GUIToolsWin.setModal(false);
            GUITools.LogMessage('GUITools Started', 1);
        },
        
        /**
        * Function to Close the GUI tools popup
        */
        closeGUITools: function(id) {
            parent.dhxWins1.window("GUITools").close();
        },

        /**Function to write the message in the ClientLog Grid
         * @param msg The Debug message to be written to the Debug Grid 
         * @param lvl The Debug level */
        LogMessage: function(msg, lvl) {
            try {
                 var newRowId=ClientLogGrid.getRowsNum();
                 newRowId=newRowId+1;
                 ClientLogGrid.addRow(newRowId, Date() + "," + msg, 0);
            }
            catch(er) {

            }       
        }
    }
} ();
//#endregion


// COP Entities 
//#region
//-------------------------
/** @namespace */
var COPEntities = window.COPEntities || {};
COPEntities = function() {
    /** @private */
    function onButtonClick(menuitemId, type) {}

    /** @private */
    //Function to show popup on selecting Entity Menu Item
    function newEntity(id, zoneId, casState) {
        if(id=="Individual" || id =="IndividualTrust" || id =="Company")
        {
            var url = "?EntID=0&EntName=''&EntType=" + EntTree.getItemText(EntTree.getSelectedRowId()) + "&EntParent=" + EntTree.getSelectedRowId()+"&Type=" + id;
            url = htmlEntPopup + url;
            COPCommon.showDHTMLXPopup(url, 50, 50, 900, 600, true, 'Entities', true); 
            GUITools.LogMessage("EntMenu Click: id=" + id + "   zoneId=" + zoneId + "   casState=" + casState, 1);
        }
        if(id=="move")
        {
            EntTree.enableDragAndDrop(true);  
        }
    }

/** @private */
    /** Method checks whether the selected entity can be moved to the target location or not*/
    function moveRow (sourceID,targetID,srcGrid,targetGrid,startIndex,lastIndex){
        var srcType = EntTree.getUserData(sourceID,"RowType");
        var trgtType = EntTree.getUserData(targetID,"RowType");
        CheckChildParentRelation(sourceID,targetID);
        var toMove = CheckMovability(srcType,trgtType)
        return toMove;
	}
	
	 /** @private */
    /** Method checks whether the selected entity can be moved to the target location or not*/
    function CheckChildParentRelation (sourceID,targetID){
        var srcType = EntTree.getUserData(sourceID,"RowType");
        var trgtType = EntTree.getUserData(targetID,"RowType");
        var parent_id = EntTree.getParentId(sourceID);    
        if(parent_id == targetID && (srcType != 'Class' && trgtType != 'Class'))
            return true;
        parent_id = EntTree.getParentId(targetID);    
        if(parent_id == sourceID && (srcType != 'Class' && trgtType != 'Class'))
            return true;
        
        return false;
	}
	
	/** @private */
    /** Method checks whether the selected entity can be moved to the target location or not*/
    function CheckMovability (srcType,trgtType){
        if(srcType == "Entity" && trgtType == "Entity")
            return true;
        else if(srcType == "Entity" && trgtType == "Class")
            return false;        
	}	
	
	/** @private */
    /** Method checks whether the selected entity should be moved or copied to the target destination*/
    function MoveOrCopy (srcID,trgtID){
        var srcType = EntTree.getUserData(srcID,"RowType");
        var srcName = EntTree.getUserData(srcID,"RowName");
        var trgtType = EntTree.getUserData(trgtID,"RowType");
        var trgtName = EntTree.getUserData(trgtID,"RowName");
        
        if(srcType == "Entity" && trgtType == "Class")
        {
            if(srcName == "Individual" && trgtName == "Individual")
                return "copy";
        }
        else if(srcType == "Entity" && trgtType == "Entity")
        {
            if(srcName == "Individual" && trgtName == "Individual")
                return "move";
            if(srcName == "Individual" && trgtName == "IndividualTrust")
                return "copy";
        }        
	}
	
    /** @private */
    function doOnClickEntTreeMenu(id, zoneId, casState) {
        GUITools.LogMessage("EntMenu Click: id=" + id + "   zoneId=" + zoneId + "   casState=" + casState, 1);
    }

    /** @private */
    function success(result) {
        EntTree.loadXMLString(result);
    }

    /** @private */
    function failure() {

    }
    
    /** @private */
   function openPopup(){
            COPCommon.showDHTMLXPopup(htmlEntPopup, 50, 50, 900, 600, true, 'Entities', true);
    }
    /** @private*/
    //Function for making all cells uneditable
    function disableEditEntity(stage, rowId, cellInd) {
        return false;
    }
    /** @private*/
    //Function for making New Entity Disabled
    function disableNewEntity(srcID){
        var srcType =   EntTree.getUserData(srcID,"RowType");
        var srcName =   EntTree.getUserData(srcID,"RowName");               
        var parentId =  EntTree.getParentId(srcID);
        var parentType =EntTree.getUserData(parentId,"RowType");
        var parentName =EntTree.getUserData(parentId,"RowName");   
        var sClass = "Class";
        var sEntity = "Entity";
        var sIndividual = "Individual";
        var sIndividualTrust= "IndividualTrust";
        var sCompany = "Company";        
        var el = document.getElementById("mEdit");
       
        if (el.childNodes && el.childNodes.length > 0) 
        {
            for (var x = 0; x < el.childNodes.length; x++) 
            {
                el.childNodes[x].disabled = false;
                el.childNodes[x].attachEvent("onclick",openPopup);                  
            }
        }
    
        if(srcType == sClass || (srcType == sEntity && srcName == sCompany))
        {
            if (el.childNodes && el.childNodes.length > 0) 
            {
                for (var x = 0; x < el.childNodes.length; x++) 
                {
                    el.childNodes[x].disabled = false;                    
                }
            }
        }   
        else if(srcType == sEntity )
        {
            if(srcName == sIndividual || srcName == sIndividualTrust)
            {                
                
                if (el.childNodes && el.childNodes.length > 0) 
                {
                    for (var x = 0; x < el.childNodes.length; x++) 
                    {
                        if (el.childNodes[x].innerText == sIndividual)
                        {
                            el.childNodes[x].disabled = false;;
                        }
                        else
                        {
                            el.childNodes[x].disabled = true;
                            el.childNodes[x].removeAttribute("href",true);
                        }
                    }
                }                
                if ((srcName == sIndividual && parentType== sEntity && (parentName == sIndividual || parentName == sIndividualTrust || parentName == sCompany)) || licenseKey == 'B')
                {
                   for (var x = 0; x < el.childNodes.length; x++) 
                    {
                        if (el.childNodes[x].innerText == sIndividual)
                        {
                            el.childNodes[x].disabled = true;
                            el.childNodes[x].removeAttribute("href",true);
                        }
                    }
                }
            }                             
        }
        
        if (licenseKey == 'MEC')
        {
            for (var x = 0; x < el.childNodes.length; x++) 
            {
                if (el.childNodes[x].innerText == sCompany)
                {
                    el.childNodes[x].disabled = true;
                    el.childNodes[x].removeAttribute("href",true);
                }
            }
        }
       
      }
    // public methods
    /** @scope COPEntities */
    return {
        /** Function to Initialize the Entities tree grid */
        initEntities: function() {
            EntTree = Accord.cells("b1").attachGrid();
            EntTree.setImagePath(imgPathTree);
            EntTree.setSkin("c594");
            COPEntities.getEntities(null);            
            EntTree.setNoHeader(true);
            EntTree.enableDragAndDrop(true);  
            EntTree.enableMercyDrag(true);
            var el = document.getElementById("mEdit");
            for (var x = 0; x < el.childNodes.length; x++) 
            {
                el.childNodes[x].disabled = true;
                el.childNodes[x].removeAttribute("href",true);
                
            }
            EntTree.attachEvent("onRowSelect", disableNewEntity);
            EntTree.attachEvent("onEditCell", disableEditEntity);
            EntTree.attachEvent("onDrag",moveRow);
            EntTree.attachEvent("onDrop",function(sourceID,targetID,srcGrid,targetGrid,startIndex,lastIndex){
                var toMove = MoveOrCopy(sourceID,targetID);
                if(toMove == "move")
                    el.childNodes[x].detachEvent("onclick",openPopup);
            }
            );
        },
        
        /** Function to get the entities */
        getEntities: function(xmlString) {
            if (xmlString != null) {
                EntTree.loadXMLString(xmlString)
            }
            else {
                if (isStaticData) {
                    EntTree.loadXML(xmlEntTree);
                }
                else {
                    var obj = new GUIServices.GUIService();
                    obj.GetEntities(success, failure);
                }
            }
        },


        


        /**  Function that deletes an item from the Entity Tree Grid */
        deleteEntity: function() {
        
            var confirmed = confirm("Are you sure you wish to delete this entry?");
            if(confirmed)
            {
                EntTree.deleteRow(EntTree.getSelectedRowId());                
                GUITools.LogMessage("Entity Item Deleted", 1);
            }
        },

        /** Function that allows the user to edit a selected Item in the Entiry Tree Grid 
         * @param id ID of the selected Entity Item to be editted */
        editEntity: function(id) {
            var cName = EntTree.cells(id, 0);
            var url = "?EntID=" + id + "&EntName=" + cName.cell.innerText + "&EntType=''" + "&EntParent=''&Type=" + id;
            url = htmlEntPopup + url;
            COPCommon.showDHTMLXPopup(url, 50, 50, 900, 600, true, 'Entities', true);
        },

        /** Function that saves the entities 
         * @param id ID of the selected Entity Item to be saved
         * @param newEntName Value of Entity Name text box
         * @param entParent ID of the Parent Entity for which an Entity item is added/ updated */
        saveEntity: function(id, newEntName, entParent, type) {
            COPCommon.closePopup();
            if (id == 0) {
                var rowId = EntTree.getRowsNum();
                rowId = rowId + 1;
                var editRow = "../imgs/edit.gif^Edit^javascript:COPEntities.editEntity(" + rowId + ");^_self";
                var delRow = "../imgs/delete.gif^Delete^javascript:COPEntities.deleteEntity();^_self";
                EntTree.addRow(rowId, [newEntName, editRow, delRow], 0, entParent);
                if(type=="Individual")
                    {EntTree.setItemImage(rowId,"../imgs/people.png","../imgs/people.png");}
                else
                    {EntTree.setItemImage(rowId,"../imgs/building.png","../imgs/building.png");}
                GUITools.LogMessage('Entity Row Added', 1);                
            }
            else {
                EntTree.cells(id, EntTree.cellType._dhx_find("tree")).setLabel(newEntName);
                GUITools.LogMessage('Entity Row Updated', 1);                
            }
        }
    }
} ();
//#endregion

// COP ThirdParty 
//#region
//-------------------------
/** @namespace */
var COPThirdParty = window.COPThirdParty || {};
COPThirdParty = function() {
    /** @scope COPThirdParty */

    /** @private */
    function success(result) {
        SerGrid.loadXMLString(result);
    }

    /** @private */
    function failure() {

    }

    return {
        /** initializes the Thrid party Services grid*/
        initThirdParty: function() {
            SerGrid = Accord.cells("b4").attachGrid();
            SerGrid.setSkin("c594");
            SerGrid.setImagePath(imgPathGrid);
            SerGrid.setNoHeader(true);
            COPThirdParty.getThirdParty(null);
            GUITools.LogMessage('Third party Services Initialized', 1);
        },

        /** function to get the third party grid data */
        getThirdParty: function(xmlString) {
            if (xmlString != null) {
                SerGrid.loadXMLString(xmlString);
            }
            else {
                if (isStaticData) {
                    SerGrid.loadXML(xmlSerGrid);
                }
                else {
                    var obj = new GUIServices.GUIService();
                    obj.GetThirdparty(success, failure);
                }
            }
        },

        /** Opens the Interface screen 
        * @param id ID of the selected Interface*/
        popServiceScreen: function(id) {
            COPCommon.showDHTMLXPopup('Page1.html', 50, 50, 900, 600, true, 'Interface', true);
        }
    }
} ();
//#endregion

// COP Collateral 
//#region
//-------------------------
/** @namespace */
var COPCollateral = window.COPCollateral || {};
COPCollateral = function() {

    /** @private*/
    //Function for making all cells uneditable
    function disableEditCollateral(stage, rowId, cellInd) {
        return false;
    }

    /** @private*/
    // Function to show popup on selecting Collateral Menu Item
    function doOnClickCollMenu(id, zoneId, casState) {
        var url = "?ColID=0&CollName=''&CollType=" + ColMenu.getItemText(id) + "&CollAmt=''" + "&ColParent=" + id;
        url = htmlColPopup + url;
        COPCommon.showDHTMLXPopup(url, 50, 50, 900, 600, true, 'Collateral', true);
        GUITools.LogMessage("CollMenu Click: id=" + id + "   zoneId=" + zoneId + "   casState=" + casState, 1);
    }

    /** @private */
    function success(result) {
        ColGrid.loadXMLString(result);
    }

    /** @private */
    function failure() {

    }
    // public methods
    /** @scope COPCollateral */
    return {
        /** Function to initialize the Collateral Grid */
        initCollateral: function() {            
            ColGrid = Accord.cells("b2").attachGrid();
            ColGrid.setSkin("c594");
//          ColMenu = Accord.cells("b2").attachMenu();
//            ColMenu.setImagePath(imgPathMenu);
//            ColMenu.setIconsPath(imgMenuIconPath);
//            ColMenu.loadXML(xmlColMenu);
//            ColMenu.attachEvent("onClick", doOnClickCollMenu);
//            
            ColGrid = Accord.cells("b2").attachGrid();
            ColGrid.setImagePath(imgPathTree);
            COPCollateral.getCollateral(null);
            ColGrid.enableDragAndDrop(false);
            ColGrid.def_line_img_x = "2px";
            ColGrid.setNoHeader(true);
            
            ColGrid.attachEvent("onEditCell", disableEditCollateral);
            GUITools.LogMessage('Collateral Initialized', 1);
        },

        /** function to get the collaterals grid data */
        getCollateral: function(xmlString) {
            if (xmlString != null) {
                ColGrid.loadXMLString(xmlString);
            }
            else {
                if (isStaticData) {
                    ColGrid.loadXML(xmlColGrid);
                }
                else {
                    var obj = new GUIServices.GUIService();
                    obj.GetCollateral(success, failure);
                }
            }
        },

        /** Function to Add/ Update the Collateral Item
        * @param id ID of the selected Collateral Item to be saved
        * @param collName Value of the Collateral Name to be saved
        * @param collType Value of the Collateral Type to be saved
        * @param collAmt Value of the Collateral Amount to be saved  */
        saveColl: function(id, collName, collAmt, colParent) {
            COPCommon.closePopup();
            if (id == 0) {
                var rowId = ColGrid.getRowsNum();
                rowId = rowId + 1;
                var editRow = "../imgs/edit.gif^Edit^javascript:COPCollateral.editColl(" + rowId + ");^_self";
                var delRow = "../imgs/delete.gif^Delete^javascript:COPCollateral.deleteColl();^_self";
                ColGrid.addRow(rowId, [collName, collAmt, editRow, delRow], 0, colParent);                
                GUITools.LogMessage('Collateral Row Added', 1);                
            }
            else {
                ColGrid.cells(id, ColGrid.cellType._dhx_find("tree")).setLabel(collName);
                ColGrid.cells(id, ColGrid.cellType._dhx_find("price")).setLabel(collAmt);
                GUITools.LogMessage('Collateral Row Updated', 1);                
            }
        },

        /** Function that deletes a item from the Collateral Grid*/
        deleteColl: function() {
            ColGrid.deleteRow(ColGrid.getSelectedId());            
        },

        /**Function that allows the user to edit a aelected Item in the Collateral Grid
        * @param id ID of the selected Collateral Item to be editted */
        editColl: function(id) {           
            var cName = ColGrid.cells(id, 0);
            var cAmt = ColGrid.cells(id, 1);           
            var url = "?ColID=" + id + "&CollName=" + cName.cell.innerText + "&CollType='' &CollAmt=" + cAmt.cell.innerText + "&ColParent=''";
            
            url = htmlColPopup + url;
            COPCommon.showDHTMLXPopup(url, 50, 50, 900, 600, true, 'Collateral', true);
        }
    }
} ();
//#endregion
//---------

// COP Ratios 
//#region
//-------------------------
/** @namespace */
var COPRatios = window.COPRatios || {};
COPRatios = function() {

     /** @private */
    function success(result) {
       var ratioObj = JSON.parse(result);        
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdLTV").innerHTML = ratioObj.tdLTV;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdCLTV").innerHTML = ratioObj.tdCLTV;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdHCLTV").innerHTML = ratioObj.tdHCLTV;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdAppraisedValue").innerHTML = ratioObj.tdAppraisedValue;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdProgLienPosition").innerHTML = ratioObj.tdProgLienPosition;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdDocType").innerHTML = ratioObj.tdDocType;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdProgLnAmt").innerHTML = ratioObj.tdProgLnAmt;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("td1stLienAmt").innerHTML = ratioObj.td1stLienAmt;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdTotalIncome").innerHTML = ratioObj.tdTotalIncome;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdDebtPayoff").innerHTML = ratioObj.tdDebtPayoff;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdCashout").innerHTML = ratioObj.tdCashout;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdProgAPR").innerHTML = ratioObj.tdProgAPR;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdFrontEnd").innerHTML = ratioObj.tdFrontEnd;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdBackEnd").innerHTML = ratioObj.tdBackEnd;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdBorrFico").innerHTML = ratioObj.tdBorrFico;
        Accord.cells("b3")._frame.contentWindow.document.getElementById("tdCoBorrFico").innerHTML = ratioObj.tdCoBorrFico;
    }

    /** @private */
    function failure() {

    }

    // public methods
    /** @scope COPRatios */
    return {
        // Initializes the Ratios Panel in the Accordion
        initRatios: function() {
            Accord.cells("b3").attachURL(htmlRatios);
            Accord.openItem("b1");            
            //COPRatios.getRatios();
            GUITools.LogMessage('Ratios Initialized', 1);
        },

        getRatios: function() {
            var obj = new GUIServices.GUIService();
            obj.GetRatios(success, failure);
        }
    }
} ();
//#endregion
//---------

// COP Common functions
//#region
//---------
/** @namespace */
var COPCommon = window.COPCommon || {};
COPCommon = function() {
    /** @private */
    var pollingInterval;
    
    /** @private */
    //Extended Function to FIND feature in javascript array
    Array.prototype.find = function(searchStr)
    {
        var returnArray = false;
        for (i=0; i<this.length; i++)
         {    if (typeof(searchStr) == 'function')
              {
                    if (searchStr.test(this[i]))
                    {
                          if (!returnArray) { returnArray = []}
                          returnArray.push(i);
                    }
              }
              else
              {
                    if (this[i]===searchStr)
                    {
                            returnArray = true;
                            //if (!returnArray) { returnArray = [] } 
                            // returnArray.push(i);
                    }
              }
         }
         return returnArray;
    }
    
     /** @private */
    function PhoneHome(){
        var obj = new GUIServices.GUIService();
        obj.GetUserNotifications(success, failure);    
    }
    
     /** @private */
    function success(result){
        //COPCommon.ShowAlert("User Notification");
    }
    
     /** @private */
    function failure(){
        COPCommon.ShowAlert("Error")
    }
    
    // public methods
    /** @scope COPCommon */
    return {
        /**
        * object to set the components that need to be refreshed
        * guiComponents object contains objects for each component in
        * the GUI framework. Each of these objects contains 2 properties-
        * one represents if the component needs to be refreshed or not and 
        * the other contains the data.
        */
        guiComponents: function() {
        
            this.LoanTabSet = function (){
                this.doLoanTabSet = false;
                this.LoanTabSetData = null;
                 this.LoanTabSetName = null;
            }
            
            this.DashBoard = function(){
                this.doDashboard = false;
                this.DashboardData = null;
            }
            
            this.Entities = function(){
                this.doEntities = false;
                this.EntitiesData = null;
            }
            
            this.Collateral = function(){
                this.doCollateral = false;
                this.CollateralData = null;    
            }
            
            this.Keywords = function(){
                this.doKeywords = false;
                this.KeywordsData = null;
            }
            
            this.ThirdParty = function(){
                this.doThirdParty = false;
                this.ThirdPartyData = null
            }
            
            this.UserContext = function(){
                this.doUserContext = false;
                this.UserContextData = null;
            }

            this.LoanContext = function(){
                this.doLoanContext = false;
                this.LoanContextData = null;
            }
                     
            this.Ratios = function(){
                this.doRatios = false;
                this.RatiosData = null;
            }
        },

        /**
        * Function to refresh the UI components
        * @param guiComponents object describing which UI components should be refreshed
        */
        refreshGUI: function(guiComponents) {
            if (guiComponents.LoanTabSet.doLoanTabSet)COPContent.getLoanTabs(guiComponents.LoanTabSet.LoanTabSetData, guiComponents.LoanTabSet.LoanTabSetName);

            if (guiComponents.DashBoard.doDashboard)COPContent.getDashboardTabs(guiComponents.DashBoard.DashboardData);

            if (guiComponents.Entities.doEntities) COPEntities.getEntities(guiComponents.Entities.EntitiesData);

            if (guiComponents.Collateral.doCollateral) COPCollateral.getCollateral(guiComponents.Collateral.CollateralData);
            
            if (guiComponents.Keywords.doKeywords) COPKeywords.getKeywords(guiComponents.Keywords.KeywordsData);
            
            if (guiComponents.ThirdParty.doThirdParty) COPThirdParty.getThirdParty(guiComponents.ThirdParty.ThirdPartyData);
            
            if (guiComponents.UserContext.doUserContext) COPContext.getUserContext(guiComponents.UserContext.UserContextData);

            if (guiComponents.LoanContext.doLoanContext) COPContext.getLoanContext(guiComponents.LoanContext.LoanContextData);
                       
            if (guiComponents.Ratios.doRatios) COPRatios.getRatios(guiComponents.Ratios.RatiosData);
        },

        /** Function to load Sub-Tabs in a page
        * @param tabbarId div tag in the page where the sub-Tabbar will be rendered 
        * @param xmlPath XML to initialize the sub-tabs */
        initSubTabs: function(tabbarId, xmlPath) {
            var divId = tabbarId.id;
            tabbar = new dhtmlXTabBar(divId, "top");
            tabbar.setImagePath(imgPathTabbar);
            tabbar.setSkin("c594");
            tabbar.loadXML(xmlPath);
            GUITools.LogMessage('Creating Subtabs', 1);
        },

//        /** Function to display a modal popup window. 
//        * @param url URL of the page to be opened as a popup */
//        showPopup: function(url) {
//            var popupWindow;
//            dhxWins1 = new dhtmlXWindows();
//            dhxWins1.setImagePath(imgPathWindow);
//            dhxWins1.setSkin("c594");
//            popupWindow = dhxWins1.createWindow("popupWindow", 50, 50, 900, 600);
//            dhxWins1.window("popupWindow").setText("Common Origination Platform from Fiserv");
//            popupWindow.attachURL(url);
//            popupWindow.show();
//            popupWindow.setModal(true);
//            dhxWins1.window("popupWindow").button("park").hide();
//            dhxWins1.window("popupWindow").button("minmax1").hide();
//            GUITools.LogMessage('Popup Initialized', 1);
//        },
        
        /** Function to display a popup window 
        * @param url URL of the page to be opened as a popup 
          @param xCoord top-left window corner's X-coordinate
          @param yCoord top-left window corner's Y-coordinate
          @param pWidth window's width
          @param pHeight window's height
          @param modalYN modal (True/ False)
          @param headerText Window title
          @param hideButtons hide minimize/ maximize buttons (True/ False)*/
        showDHTMLXPopup: function(url, xCoord, yCoord, pWidth, pHeight, modalYN, headerText, hideButtons) {
            var popupWindow;
            dhxWins1 = new dhtmlXWindows();
            dhxWins1.setImagePath(imgPathWindow);
            dhxWins1.setSkin("c594");
            popupWindow = dhxWins1.createWindow("popupWindow", xCoord, yCoord, pWidth, pHeight);
            dhxWins1.window("popupWindow").setText(headerText);
            popupWindow.attachURL(url);
            popupWindow.show();
            popupWindow.setModal(modalYN);
            if(hideButtons==true)
            {
                dhxWins1.window("popupWindow").button("park").hide();
                dhxWins1.window("popupWindow").button("minmax1").hide();
            }
            GUITools.LogMessage(headerText + 'Popup Initialized', 1);
        },

//        /** Function to display a modal popup window inside a popup. 
//        * @param url URL of the page to be opened as a popup */
//        showPopupInPopup: function(url) {
//            var popupWindow;
//            dhxWins1 = new dhtmlXWindows();
//            dhxWins1.setImagePath(imgPathWindow);
//            dhxWins1.setSkin("c594");
//            popupWindow = dhxWins1.createWindow("popupWindow", 100, 100, 700, 450);
//            dhxWins1.window("popupWindow").setText("Common Origination Platform from Fiserv");
//            popupWindow.attachURL(url);
//            popupWindow.show();
//            popupWindow.setModal(true);
//            dhxWins1.window("popupWindow").button("park").hide();
//            dhxWins1.window("popupWindow").button("minmax1").hide();
//            GUITools.LogMessage('Popup Initialized', 1);
//        },
    
//         /** Function to display a modal popup window inside a popup. 
//        * @param url URL of the page to be opened as a popup */
//        showNonModalPopup: function(url) {
//            var popupWindow;
//            dhxWins1 = new dhtmlXWindows();
//            dhxWins1.setImagePath(imgPathWindow);
//            dhxWins1.setSkin("c594");
//            popupWindow = dhxWins1.createWindow("popupWindow", 50, 50, 900, 600);
//            dhxWins1.window("popupWindow").setText("Common Origination Platform from Fiserv");
//            popupWindow.attachURL(url);
//            popupWindow.show();
//            popupWindow.setModal(false);
//            GUITools.LogMessage('Popup Initialized', 1);
//        },
        
       
        /** Function to close the popup window */
        closePopup: function() {
            parent.dhxWins1.window("popupWindow").close();
        },

        /** Function to set the message in the Status Bar 
        * @param statusMsg The message./ text to be shown in the Status Bar*/
        setStatus: function(statusMsg) {
            Status.setText(statusMsg);
        },
        
        /** Function to show the dhtmlx window alert
        * @param msg The message to be alerted */
        ShowAlert : function (msg){
		    var alertWindow;
            dhxWins1 = new dhtmlXWindows();
            dhxWins1.setImagePath(imgPathWindow);
            dhxWins1.setSkin("c594");
            alertWindow = dhxWins1.createWindow("alertWindow", 10, 10, 350, 150);
            dhxWins1.window("alertWindow").setText("Common Origination Platform from Fiserv");
            
            alertWindow.attachURL(htmlCOPAlert + "?" + msg);
            alertWindow.show();
            alertWindow.setModal(true);
            dhxWins1.window("alertWindow").button("park").hide();
            dhxWins1.window("alertWindow").button("minmax1").hide();
            dhxWins1.window("alertWindow").button("close").hide();
            dhxWins1.window("alertWindow").center();            
		}
    }    
} ();
//#endregion
